<?php
$updates['0.10.3'] = [
    'funktion' => 'anfang',
    'confignichtaktualisieren' => true
];

function update_0_10_3()
{
    global $_db;

    # Admin-Passwort als Hash speichern
    $info = password_get_info(TKSWIM_ADMINPASSWORT);
    if ($info['algoName'] == 'unknown') {
        $daten = [
            'tkswim_version' => '0.10.3',
            'tkswim_adminpasswort' => password_hash(TKSWIM_ADMINPASSWORT, PASSWORD_DEFAULT),
        ];
        aktualisiereDatei('config', $daten);
    }

    # ggf. Spalte "emailspeicherungok" in Mitgliedertabelle anlegen
    $query = "SELECT 1 as ok FROM information_schema.COLUMNS 
               WHERE TABLE_SCHEMA = '".DB_NAME."' 
                 AND TABLE_NAME = '".DB_PREFIX."mitglieder' 
                 AND COLUMN_NAME = 'emailspeicherungok'";
    $_db->holeDaten($query);
    if($_db->holeAnzahl() != 1){
        $query = "ALTER TABLE ".DB_PREFIX."mitglieder ADD emailspeicherungok char(1) NOT NULL DEFAULT '0' AFTER email";
        $_db->fuehreQueryAus($query);
    }
}
# EOF
