<?php
/*
Wettkampfabwicklung, Aktion: kampfrichter
verwendete Templates:
  - 42.abwickeln-kampfrichter.inc.html
  - 42.abwickeln_kampfrichter_eigenemeldung.inc.html
*/
$_nureigene = (pruefeRechte('w_abwickeln_eigenekarimeldung') and !pruefeRechte('w_abwickeln_kampfrichter'));
# Kampfrichter
$query = "SELECT k.id as id, CONCAT(m.nachname,', ',m.vorname) as name, gruppe
			FROM ".DB_PREFIX."kampfrichter as k, ".DB_PREFIX."mitglieder as m
			WHERE k.id = m.id AND YEAR(NOW()) <= gueltigbis AND m.ausgetreten IS NULL ORDER BY name";
$_db->holeDaten($query);
$kampfrichter = $_db->baueArray('*','id');
$_tmpl->assign('karigruppen',$_kampfrichtergruppen);
# Abschnitte
$tmp = $wk->holeAbschnitte($_SESSION['wk_abwickeln']['id']);
if(count($tmp)<1){
	$_tmpl->assign('fehler', 'Zu dem Wettkampf wurden noch keine Abschnitte angelegt');
}
else{
$abschnitte = array();
foreach($tmp as $id => $abschn){
	$abschnitte['detail'][$id] = $abschn['nr'].'. Abschnitt: '.$_wochentage[$abschn['wochentag']].', '.$abschn['datum'].', '.$abschn['beginn'].($abschn['kindgerecht']?' (kindgerecht)':'');
	$abschnitte['kurz'][$id] = $abschn['nr'].'. Abschnitt';
}

if($_nureigene){
	if(!isset($kampfrichter[$_SESSION['user']['id']])){
		$_tmpl->assign('fehler', 'Nur Kampfrichter können diese Funktion verwenden');
	}
	else{
		$kariid = $_SESSION['user']['id'];
		if(isset($_POST['speichern'])){
			$wertalt = isset($_wkeinst['kampfrichter'][$kariid])?$_wkeinst['kampfrichter'][$kariid]:'';
			$wertneu = '';
			if(isset($_POST['eigene']) and count($_POST['eigene'])>0){
				foreach($_POST['eigene'] as $key => $id){
					if(!array_key_exists($id,$abschnitte['kurz'])){
						unset($_POST['eigene'][$key]);
					}
				}
				$wertneu = implode(',',$_POST['eigene']);
			}
			if($wertalt != $wertneu){
				if($wertneu == ''){
					unset($_wkeinst['kampfrichter'][$kariid]);
				}
				else{
					$_wkeinst['kampfrichter'][$kariid] = $wertneu;
				}
				schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'], $_wkeinst, true);
			}
			weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=kampfrichter','Die Kampfrichtereinstellungen wurden gespeichert');
		}
		else{
			$vorh = array();
			$eigene = array();
			foreach($_wkeinst['kampfrichter'] as $id => $kari){
				if($id == $kariid){
					$eigene = explode(',',$kari);
				}
				else{
					$tmp = explode(',',$kari);
					foreach($tmp as $t){
						if(!isset($vorh[$t])){
							$vorh[$t] = 0;
						}
						$vorh[$t]++;
					}
				}
			}
			foreach($vorh as $id => $anz){
				if(!isset($abschnitte['kurz'][$id])){
					continue;
				}
				$abschnitte['kurz'][$id] .= ' ('.$anz.' Meldung'.($anz==1?'':'en').' anderer Kampfrichter)';
			}
			$_tmpl->assign('eigene', $eigene);
		}
		$_tmpl->assign('kampfrichter', $kampfrichter[$kariid]);
		$_tmpl->assign('abschnitte',$abschnitte);
		$_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-kampfrichter_eigenemeldung.inc.html');
	}
}
else{
	$_tmpl->assign('kampfrichter',$kampfrichter);
	if(isset($_POST['speichern'])){
		$_wkeinst['kampfrichter'] = array();
		if(isset($_POST['kariabschnitte']) and count($_POST['kariabschnitte'])>0){
			foreach($_POST['kariabschnitte'] as $id => $kari){
				foreach($kari as $tmpid => $k){
					if(!in_array($k,array_keys($abschnitte['kurz']))){
						unset($kari[$tmpid]);
					}
				}
				if(count($kari) < 1){
					continue;
				}
				$_wkeinst['kampfrichter'][$id] = implode(',',$kari);
			}
		}
		schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
		weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=kampfrichter','Die Kampfrichtereinstellungen wurden gespeichert');
	}
	else{
		$vorhandene = array();
		foreach($_wkeinst['kampfrichter'] as $id => $kari){
			$vorhandene[$id] = explode(',',$kari);
		}
		$_tmpl->assign('vorhandene',$vorhandene);
	}
	$_tmpl->assign('abschnitte',$abschnitte);
	$_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-kampfrichter.inc.html');
}
} # Ende else bei der Abfrage auf vorhandene Abschnitte
# EOF
?>