<?php
/*
prüft ob für den angemeldeten User der Zugriff erlaubt ist oder nicht
(liefert true oder false zurück)

Parameter:
 die Funktion erwartet beliebig viele Parameter (oder einen Parameter mit den
 entsprechenden Rechten als Array) - wenn der User auf mindestens einen
 Zugreifen darf, liefert die Funktion true; erlaubt ist auch z.B. e_*, in dem
 Fall liefert die Funktion true wenn der User ein beliebiges Recht das mit e_
 anfängt hat.
*/
function pruefeRechte(){
	if(!isset($_SESSION['user']['rechte'])){
		return false;
	}
	$rechte = func_get_args();
	if(is_array($rechte[0])){
		$rechte = $rechte[0];
	}
	foreach($rechte as $r){ # auf einzelne Rechte prüfen
		if(strpos($r, ',')!==false){
			$r = explode(',',$r);
			foreach($r as $r2){		
				if(in_array($r2,$_SESSION['user']['rechte'])){
					return true;
				}
			}
		}
		else{
			if(in_array($r,$_SESSION['user']['rechte'])){
				return true;
			}
		}
	}
	foreach($rechte as $r){ # auf Gruppenrechte prüfen
		if(substr($r,-1) != '*'){
			continue;
		}
		$bereich = substr($r,0,-1);
		foreach($_SESSION['user']['rechte'] as $re){
			if(substr($re,0,strlen($bereich)) == $bereich){
				return true;
			}
		}
	}
	return false;
}
# EOF
?>