<?php
/*
 Original-Smarty Plugin, aber von mir modifiziert
 Aenderungen:
  - Umsetzung der englischen Tage in deutsche
  - Standardformat von '%b %e, %Y' auf '%d.%m.%Y' geaendert
*/
require_once $smarty->_get_plugin_filepath('shared','make_timestamp');
function smarty_modifier_date_format($string, $format='%d.%m.%Y', $default_date=null){
    if (substr(PHP_OS,0,3) == 'WIN'){
           $_win_from = array ('%e',  '%T',       '%D');
           $_win_to   = array ('%#d', '%H:%M:%S', '%m/%d/%y');
           $format = str_replace($_win_from, $_win_to, $format);
    }
    $rueckgabe = '';
    if($string != '') {
        $rueckgabe = strftime($format, smarty_make_timestamp($string));
    } elseif (isset($default_date) && $default_date != '') {
        $rueckgabe = strftime($format, smarty_make_timestamp($default_date));
    } else {
        return;
    }
    # ersetzen der entlichen Tage durch die deutschen
    $von_lang = array('Monday','Tuesday','Wednesday','Thursday','Friday','Saturday','Sunday');
    $von_kurz = array('Mon','Tue','Wed','Thu','Fri','Sat','Sun');
    global $_wochentage;
    $nach_lang = $nach_kurz = $_wochentage;
    for($i=1;$i<=7;$i++){
    	$nach_kurz[$i] = substr($nach_kurz[$i],0,2);
    }
    $rueckgabe = str_replace($von_lang,$nach_lang,$rueckgabe);
    $rueckgabe = str_replace($von_kurz,$nach_kurz,$rueckgabe);
    $rueckgabe = str_replace('Motag',$nach_lang[1],$rueckgabe);# Montagkorrektur
    return $rueckgabe;
}
# EOF
?>