<?php
require_once('../__inc/_start.inc.php');
$_seite = 13;
$erlaubt = pruefeRechte('m_kampfrichter_anzeigen');
$_tmpl->assign('ueberschrift','Kampfrichter');
$titel = 'Kampfrichter';
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'anlegen':
	if(!pruefeRechte('m_kampfrichter_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('ueberschrift','Kampfrichter anlegen');
	if(!isset($_GET['id'])){
		require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
		$_inh .= mitgliedwaehlen('/mitglieder/kampfrichter'.TKSWIM_DATEIENDUNG, 'aktion=anlegen');
	}
	else{
		$_tmpl->assign('karigr',$_kampfrichtergruppen);
		if(!isset($_POST['speichern'])){
			$query = "SELECT CONCAT(vorname,' ',nachname) as name
						FROM ".DB_PREFIX."mitglieder
						WHERE id = '".text_format($_GET['id'],'db')."'";
			$_db->holeDaten($query);
			$daten = $_db->holeZeile();
			if($daten === false){
				$_tmpl->assign('fehler','Das Mitglied wurde nicht gefunden');
				require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
				$_inh .= mitgliedwaehlen('/mitglieder/kampfrichter'.TKSWIM_DATEIENDUNG, 'aktion=anlegen');
				break;
			}
			$_tmpl->assign('daten',$daten);
		}
		else{
			$f = '';
			require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			$f .= pruefen($_POST['gueltigbis'],'leer','Das gültig-bis-Jahr fehlt');
			$f .= pruefen($_POST['gueltigbis'],'regexpr','Das Feld »gültig bis« enthält kein gültiges Jahr','^20[0-9]{2}$');
			$f .= pruefen($_POST['gruppe'],'leer','Die Gruppe fehlt');
			$f .= pruefen($_POST['gruppe'],'wertemenge','Die Gruppe ist ungültig',array_keys($_kampfrichtergruppen));
			$query = "SELECT id FROM ".DB_PREFIX."kampfrichter WHERE id = ".$_GET['id']."";
			$_db->holeDaten($query);
			if($_db->ergebnis['anzahl'] != 0){
				$f .= 'Der Kampfrichter existiert schon<br />';
			}
			if(empty($f)){
				$query = "INSERT INTO ".DB_PREFIX."kampfrichter
							SET
							  gueltigbis = '".text_format($_POST['gueltigbis'],'db')."',
							  gruppe = '".text_format($_POST['gruppe'],'db')."',
							  id = ".text_format($_GET['id'],'db')."";
				$_db->fuehreQueryAus($query);
				$hinweis = 'Der Kampfrichter »'.$_POST['name'].'« wurde angelegt';
				require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
				mitglieder_rechtegruppensetzen($_GET['id']);
				if(!isset($_POST['anschl']) OR (isset($_POST['anschl']) AND $_POST['anschl'] == 'uebers')){
					weiterleiten('/mitglieder/kampfrichter'.TKSWIM_DATEIENDUNG,$hinweis);
				}
				else{
					weiterleiten('/mitglieder/kampfrichter'.TKSWIM_DATEIENDUNG.'?aktion=anlegen',$hinweis);
				}
			}
			else{
				$_tmpl->assign('daten',$_POST);
				$_tmpl->assign('fehler',$f);
			}
		}
		$_inh = $_tmpl->fetch('mitglieder/13.kampfrichter-formular.inc.html');
	}
	break;
case 'aendern':
	if(!pruefeRechte('m_kampfrichter_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!isset($_GET['id']) or !ctype_digit($_GET['id'])){
		break;
	}
	$_tmpl->assign('ueberschrift','Kampfrichter ändern');
	$_tmpl->assign('karigr',$_kampfrichtergruppen);
	if(!isset($_POST['speichern'])){
		$query = "SELECT k.id as id, CONCAT(m.vorname,' ',m.nachname) as name, gueltigbis, gruppe
					FROM ".DB_PREFIX."kampfrichter as k, ".DB_PREFIX."mitglieder as m
					WHERE k.id = m.id AND k.id = ".$_GET['id']."";
		$_db->holeDaten($query);
		$_tmpl->assign('daten',$_db->holeZeile());
		$_inh .= $_tmpl->fetch('mitglieder/13.kampfrichter-formular.inc.html');
	}
	else{
		$f = '';
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			$f .= pruefen($_POST['gueltigbis'],'leer','Das gültig-bis-Jahr fehlt');
			$f .= pruefen($_POST['gueltigbis'],'regexpr','Das Feld »gültig bis« enthält kein gültiges Jahr','^20[0-9]{2}$');
		$f .= pruefen($_POST['gruppe'],'leer','Die Gruppe fehlt');
		$f .= pruefen($_POST['gruppe'],'wertemenge','Die Gruppe ist ungültig',array_keys($_kampfrichtergruppen));
		if(empty($f)){
			$query = "UPDATE ".DB_PREFIX."kampfrichter
						SET
						  gueltigbis = '".text_format($_POST['gueltigbis'],'db')."',
						  gruppe = '".text_format($_POST['gruppe'],'db')."'
						WHERE id = ".$_GET['id']."";
			$_db->fuehreQueryAus($query);
			require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
			mitglieder_rechtegruppensetzen($_GET['id']);
			weiterleiten('/mitglieder/kampfrichter'.TKSWIM_DATEIENDUNG,'Der Kampfrichter »'.$_POST['name'].'« wurde geändert');
		}
		else{
			$_tmpl->assign('daten',$_POST);
			$_tmpl->assign('fehler',$f);
			$_inh .= $_tmpl->fetch('mitglieder/13.kampfrichter-formular.inc.html');
		}
	}
	break;
case 'loeschen':
	if(!pruefeRechte('m_kampfrichter_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('ueberschrift','Kampfrichter löschen');
	if(!isset($_GET['sicher'])){
		$_tmpl->assign('frage','Soll der Kampfrichter wirklich gelöscht werden?');
		$_tmpl->assign('url', '/mitglieder/kampfrichter'.TKSWIM_DATEIENDUNG);
		$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
	}
	else{
		$query = "DELETE FROM ".DB_PREFIX."kampfrichter WHERE id = '".text_format($_GET['id'],'db')."'";
		$_db->fuehreQueryAus($query);				
		require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
		mitglieder_rechtegruppensetzen($_GET['id']);
		weiterleiten('/mitglieder/kampfrichter'.TKSWIM_DATEIENDUNG, $_db->holeAnzahl()>0?'Der Kampfrichter wurde gelöscht':'');
	}
	break;
default:
	$query = "SELECT k.id as id, CONCAT(m.nachname,', ',m.vorname) as name, gueltigbis, gruppe, ausgetreten, email
				FROM ".DB_PREFIX."kampfrichter as k, ".DB_PREFIX."mitglieder as m
				WHERE k.id = m.id ORDER BY name";
	$_db->holedaten($query);
	$_tmpl->assign('aktujahr',date('Y'));
	$_tmpl->assign('karigr',$_kampfrichtergruppen);
	$_tmpl->assign('kampfrichter',$_db->baueArray('*','#'));
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschen').tkswim_loeschfrage({art:'kampfrichter',frage:'Soll der Kampfrichter%%% wirklich gelöscht werden?',tabellenid:'kampfrichter'});");
	$_inh .= $_tmpl->fetch('mitglieder/13.kampfrichter-uebersicht.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>