<?php

class email{

var $an;
var $betreff;
var $text;
var $header = array();
var $parameter;
var $speicher = array();

function setzeAnhang($art, $id){
	if(!isset($this->speicher['anhaenge'])){
		$this->speicher['anhaenge'] = array();
		$this->speicher['trenner'] = md5(uniqid(time()));
	}
	$this->setzeHeader('Content-Type', 'multipart/mixed; boundary='.$this->speicher['trenner']);
	$this->setzeHeader('MIME-Version', '1.0');

	if($art == 'tmp'){
		$datei = PFAD_TMP.$id;
		$dateien = parse_ini_file(PFAD_INIDATEIEN.'dateien_tmp.ini');
		list(,,$dateiname) = explode('|',$dateien[$id]);
	}
		
	$this->speicher['anhaenge'][] = array(
		'content-type' => 'application/octet-stream',
		'name' => $this->_bereinigeDateiname($dateiname),
		'daten' => file_get_contents($datei)
	);
}

function _bereinigeDateiname($dateiname){
	$von = array(' ','ö','ä','ü','ß');
	$nach = array('','oe','ae','ue','ss');
	$dateiname = str_replace($von, $nach, strtolower($dateiname));
	$dateiname = preg_replace('~[^a-z0-9_\.-]~','',$dateiname);
	return $dateiname;
}

function setzeAn($wert, $pruefen = true){
	if($pruefen){
		$this->an = $this->_ersteZeile($wert);
	}
	else{
		$this->an = $wert;
	}
	return true;
}

function setzeBetreff($wert, $pruefen = true){
	if($pruefen){
		$wert = $this->_ersteZeile($wert);
	}
	$this->betreff = $this->_kodiereHeader(trim($wert));
	return true;
}

function setzeText($wert, $anhaengen = false){
	if($anhaengen){
		$this->text .= $wert;
	}
	else{
		$this->text = $wert;
	}
	return true;
}

function setzeParameter($wert, $anhaengen = false){
	if($anhaengen){
		$this->parameter .= $wert;
	}
	else{
		$this->parameter = $wert;
	}
	return true;
}

function setzeTextString($string, $empfaenger=false){
	if($empfaenger === false){
		$this->text = $string;
	}
	else{
		$this->setzeAn($empfaenger['email'],true);
		$von = array('{vname}','{nname}','{herrfrau}','{r}');
		$nach = array($empfaenger['vorname'],$empfaenger['nachname'],($empfaenger['mw']=='m'?'Herr':'Frau'),($empfaenger['mw']=='m'?'r':''));
		$this->text = str_replace($von, $nach, $string);
	}
	return true;
}

function setzeTextTemplate($templatedatei, &$smarty, $empfaenger, $variablen = ''){
	if(is_array($variablen)){
		foreach($variablen as $key => $value){
			$smarty->assign($key, $value);
		}
	}
	if(!isset($this->conf)){
		$this->conf = parse_ini_file(PFAD_INCLUDE.'conf/emails.ini',true);
	}
	$this->setzeAn($empfaenger['email'],true);
	$von = array('[br]','{vname}','{nname}','{herrfrau}','{r}');
	$nach = array("\n",$empfaenger['vorname'],$empfaenger['nachname'],($empfaenger['mw']=='m'?'Herr':'Frau'),($empfaenger['mw']=='m'?'r':''));
	$smarty->assign('_begruessung',    str_replace($von,$nach,$this->conf['textteile']['begruessung']));
	$smarty->assign('_verabschiedung', str_replace('[br]',"\n",$this->conf['textteile']['verabschiedung']));
	$smarty->assign('_dusie', $this->conf['sonstiges']['dusie']);
	$this->text = $smarty->fetch($templatedatei);
	return true;
}

function setzeHeader($header, $wert){
	$erlaubte = array(
		'CC','BCC','From','Reply-To',
		'User-Agent','X-PHP-Script',
		'Content-Transfer-Encoding','Content-Type','MIME-Version'
	);
	if(!in_array($header, $erlaubte)){
		return false;
	}
	if(in_array($header, array('CC', 'From', 'Reply-To'))){
		$wert = preg_replace_callback('~^([^<]*) <(.*)>~', array($this, '_kodiereFrom'), $wert);
	}
	$this->header[$header] = $this->_ersteZeile($wert);
	return true;
}

function _kodiereFrom($match){
	return $this->_kodiereHeader($match[1])." <".$match[2].">";
}

function _kodiereHeader($wert){
	if(!preg_match('~[^a-zA-Z0-9\[\]=()":,. _-]~', $wert)){
		return $wert;
	}
	return '=?UTF-8?Q?'.$this->php_quot_print_encode($wert).'?=';
}

function verschickeMail(){
	if(!isset($this->header['User-Agent']) or empty($this->header['User-Agent'])){
		$this->header['User-Agent'] = 'tkswim '.TKSWIM_VERSION;
	}
	if(!isset($this->header['From'])){
		$this->header['From'] = $this->_kodiereHeader($this->conf['absender']['name']).' <'.$this->conf['absender']['email'].'>';
	}
	if(!isset($this->header['Content-Type'])){
		$this->header['Content-Type'] = 'text/plain; charset=UTF-8';
	}
	if(!empty($this->conf['sonstiges']['fparameter'])){
		$this->setzeParameter('-f '.$this->conf['sonstiges']['fparameter']);
	}

	$header = '';
	foreach($this->header as $key => $value){
		$header .= $key.': '.$value."\r\n";
	}
	$header = trim($header);
	
	if(isset($this->speicher['anhaenge'])){
		$br = "\r\n";
		$neuertext = 'This is a multi-part message in MIME format.'.$br;
		$neuertext .= '--'.$this->speicher['trenner'].$br.'Content-Type: text/plain; charset=UTF-8'.$br;
		$neuertext .= 'Content-Transfer-Encoding: 7bit'.$br.$br.$this->text.$br;
		
		foreach($this->speicher['anhaenge'] as $anhang){
			$neuertext .= '--'.$this->speicher['trenner'].$br;
			$neuertext .= 'Content-Type: '.$anhang['content-type'].'; name="'.$anhang['name'].'"'.$br;
			$neuertext .= 'Content-Transfer-Encoding: base64'.$br;
			$neuertext .= 'Content-Disposition: attachment; filename="'.$anhang['name'].'"'.$br.$br;
			$neuertext .= chunk_split(base64_encode($anhang['daten'])).$br;			
		}
		$this->text = $neuertext;#.'--'.$this->speicher['trenner'];
	}
	
	if(TKSWIM_DEBUG){
		$tmp = '<strong>An:</strong> '.text_format($this->an,'htmlmaskieren').'<br />';
		$tmp .= '<strong>Betreff:</strong> '.text_format($this->betreff,'htmlmaskieren').'<br />';
		$tmp .= '<strong>Text:</strong><pre>'.text_format($this->text,'htmlmaskieren').'</pre>';
		$tmp .= '<strong>Header:</strong><pre>'.text_format($header,'htmlmaskieren').'</pre>';
		$tmp .= '<strong>Parameter:</strong> '.text_format($this->parameter,'htmlmaskieren').'<br />';
		echo $tmp.'<hr />';
		exit;
		return;
	}

	if(empty($this->an)){
		return 'es wurde keine Empfänger angegeben';
	}
	if(empty($this->betreff)){
		return 'es wurde keine Betreff angegeben';
	}
	if(empty($this->text)){
		return 'es wurde kein Text angegeben';
	}

	$erfolg = mail($this->an, $this->betreff, $this->text, $header, $this->parameter);
	return $erfolg;
}

function php_quot_print_encode($str){
	# aus http://de.php.net/manual/en/function.quoted-printable-encode.php#106078
	$lp = 0;
	$ret = '';
	$hex = "0123456789ABCDEF";
	$length = strlen($str);
	$str_index = 0;
    while($length--){
		if((($c = $str[$str_index++]) == "\015") && ($str[$str_index] == "\012") && $length > 0){
			$ret .= "\015";
			$ret .= $str[$str_index++];
			$length--;
			$lp = 0;
		}
		else{
			if(ctype_cntrl($c) || (ord($c) == 0x7f) || (ord($c) & 0x80) || ($c == '=') || (($c == ' ') && ($str[$str_index] == "\015"))){
				if(($lp += 3) > 75){
					$ret .= '=';
					$ret .= "\015";
					$ret .= "\012";
					$lp = 3;
				}
				$ret .= '=';
				$ret .= $hex[ord($c) >> 4];
				$ret .= $hex[ord($c) & 0xf];
			} 
			else{
				if((++$lp) > 75){
					$ret .= '=';
					$ret .= "\015";
					$ret .= "\012";
					$lp = 1;
				}
				$ret .= $c;
			}
		}
	}
	return str_replace(' ','_',$ret);
}
 
function _ersteZeile($wert){
	$anz = preg_match("~^(.*?)(\015\012|\015|\012)~",$wert,$match);
	if($anz == 0){
		return $wert;
	}
	return $match[1];
}

} # Ende der Klasse, EOF
?>