<?php
# Modul: wkabwickeln_dmsj
/*
Wettkampfabwicklung, Aktion: dmsj_meldeformular
verwendete Templates:
 - [keines]
*/
require_once(PFAD_INCLUDE.'class/ooodateien.inc.php');
$ooo = new ooodateien($_tmpl,'dmsjmeldebogen');
# Mannschaftsdaten
$daten = array();
$nummern = array();
foreach($_wkeinst['dmsj'] as $key => $mitgl){
	if(empty($mitgl)){ # fuer diese Mannschaft sind keine Mitglieder gesetzt
		continue;
	}
	$tmp = array();
	$tmp['jugend'] = substr($key,0,1);
	#$tmp['nr'] = substr($key,1);
	$tmp['m'] = false;
	$tmp['w'] = false;
	$query = "SELECT id as nr, nachname, vorname, YEAR(gebdatum) as jg, dsvid, mw FROM ".DB_PREFIX."mitglieder
				WHERE id IN (".str_replace('|',',',$mitgl).") ORDER BY nachname, vorname";
	$_db->holeDaten($query);
	$tmp['_mitglieder'] = $_db->baueArray('*','#');
	for($i=1;$i<=10;$i++){
		if(!isset($tmp['_mitglieder'][$i-1])){
			$tmp['_mitglieder'][$i-1] = array(
				'nr'       => $i,
				'nachname' => '',
				'vorname'  => '',
				'jg'       => '',
				'dsvid'    => ''
			);
			continue;
		}
		$tmp['_mitglieder'][$i-1]['nr'] = $i;
	}
	$mw = $_db->baueArray('mw','#');
	foreach($mw as $g){
		if($g == 'm'){
			$tmp['m'] = true;
		}
		if($g == 'w'){
			$tmp['w'] = true;
		}
	}
	# Manschaftsnummer zuweisen
	if(!isset($nummern[$tmp['jugend']])){
		$nummern[$tmp['jugend']] = array();
	}
	$mw = ($tmp['m'] and $tmp['w'])?'x':($tmp['m']?'m':'w');
	if(!isset($nummern[$tmp['jugend']][$mw])){
		$nummern[$tmp['jugend']][$mw] = 1;
	}
	else{
		$nummern[$tmp['jugend']][$mw]++;
	}
	$tmp['nr'] = $nummern[$tmp['jugend']][$mw];
	$daten[] = $tmp;
}

# Ansprechpartner
$query = "SELECT mitgliedid FROM ".DB_PREFIX."vorstand WHERE id = ".$_wkeinst['meldedatei']['ansprechpartner']."";
$_db->holeDaten($query);
$mid = $_db->holeWert();
$query = "SELECT CONCAT(nachname,', ',vorname) as name, CONCAT(strasse,' ',hausnr) as strasse, CONCAT(plz,' ',ort) as plzort, email
			FROM ".DB_PREFIX."mitglieder WHERE id = ".$mid."";
$_db->holeDaten($query);
$ansprechpartner = $_db->holeZeile();
$query = "SELECT CONCAT(vorwahl,'/',nummer) as tel FROM ".DB_PREFIX."telefon WHERE mitgliedid = ".$mid." AND telefonart = 1 ORDER BY tel";
$_db->holeDaten($query);
if($_db->ergebnis['anzahl'] != 0){
	$ansprechpartner['tel'] = $_db->holeWert();
}
else{
	$ansprechpartner['tel'] = '';
}
# Metadaten
$_meta = array(
	'generator' => 'tkswim '.TKSWIM_VERSION,
	'titel'     => 'DMS-J-Meldebogen (DSV-Form 106)',
	'creator'   => $_SESSION['user']['realname'],
	'date'      => date('Y-m-d\TH:i:s')
);
# Vereinsdaten
$verein = array(
	'name'  => TKSWIM_VEREIN,
	'id'    => TKSWIM_VEREINSID,
	'lsvnr' => TKSWIM_LSVKENNZIFFER
);
# Wettkampfdaten
$wkdat = array(
	'name'  => text_format($_wkeinst['meldedatei']['dmsjwettbewerb'],'htmlmaskieren'),
	'datum' => '',
	'ort'   => '',
	'teilnahmenaechsteebene' => $_wkeinst['meldedatei']['teilnahmenaechsteebene']
);
$query = "SELECT DATE_FORMAT(datum,'%d') as tag, DATE_FORMAT(datum,'%d.%m.%Y') as ausgdatum FROM ".DB_PREFIX."abschnitte
			WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." GROUP BY datum ORDER BY datum ASC";
$_db->holeDaten($query);
$termine = $_db->baueArray('*','#');
if($_db->ergebnis['anzahl'] == 1){
	$wkdat['datum'] = $termine[0]['ausgdatum'];
}
elseif($_db->ergebnis['anzahl'] == 2){
	$wkdat['datum'] = $termine[0]['tag'].'./'.$termine[1]['ausgdatum'];
}
else{
	$wkdat['datum'] = $termine[0]['tag'].'.-'.$termine[$_db->ergebnis['anzahl']-1]['ausgdatum'];
}
$query = "SELECT ort FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$_SESSION['wk_abwickeln']['id']."";
$_db->holeDaten($query);
$wkdat['ort'] = $_db->holeWert();
# Daten an Klasse uebergeben
$ooo->setzeWerte('daten',$daten);
$ooo->setzeWerte('_meta',$_meta);
$ooo->setzeWerte('ansprechpartner',$ansprechpartner);
$ooo->setzeWerte('verein',$verein);
$ooo->setzeWerte('wk',$wkdat);
$ooo->setzeEinstellung('ooo:configuration-settings','AddParaTableSpacingAtStart','boolean',true);
# Datei generieren
$ooo->generiereDateien();
$ooo->setzeDateiname('dmsjmeldebogen.odt');
$ooo->gebeOooDateiAus();
# EOF
?>