<?php
function generierePasswort($laenge = 8){
	$zeichen = array( # als Kommentar die fehlenden Buchstaben (um Verwechslungen zu vermeiden)
		'abcdefghijkmnpqrstuvwxyz', # lo (=LO)
		'ABCDEFGHJKLMNPQRSTUVWXYZ', # IO (=io)
		'123456789' # 0
	);
	require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
	$pwschlecht = true;
	while($pwschlecht){
		$tmp = '';
		$pwschlecht = true;
		for($i=0;$i<$laenge*1.5;$i++){
			switch($i%3){
			case '2':
				$zahl = mt_rand(0,strlen($zeichen[0])-1);
				$tmp .= $zeichen[0][$zahl];
				break;
			case '1':
				$zahl = mt_rand(0,strlen($zeichen[1])-1);
				$tmp .= $zeichen[1][$zahl];
				break;
			case '0':
				$zahl = mt_rand(0,strlen($zeichen[2])-1);
				$tmp .= $zeichen[2][$zahl];
				break;
			}
		}
		$tmp = str_shuffle($tmp);
		$pw = substr($tmp,0,$laenge);
		if($laenge < 8){ 
			# wenn das Passwort weniger als 8 Zeichen enthalten soll wird die Kontrolle auf ein sicheres Passwort 
			#  abgeschaltet (wird nur bei eimal-Passwörtern verwendet!)
			$f = '';
		}
		else{
			$f = pruefen($pw,'passwort','-');
		}
		if(empty($f)){
			$pwschlecht = false;
		}
	}
	return $pw;
}
# EOF
?>