<?php

function wettkaempfe_leseAbzuwickelndeEin($erzwingen = false){
	global $_db, $_gleinst;
	$_allerechte = pruefeRechte('w_abwickeln_allebearbeiten');
	$_uid = $_SESSION['user']['id'];

	if(isset($_GET['ansichtaendern']) and isset($_SESSION['user']['wkabwickeln']) and $_SESSION['user']['wkabwickeln']['menge'][0]=='+'){
		$erzwingen = true;
		$_SESSION['user']['wkabwickeln']['menge']=$_SESSION['user']['wkabwickeln']['menge']=='+t'?'+a':'+t';
	}

	if(!isset($_SESSION['user']['wkabwickeln'])){
		$_SESSION['user']['wkabwickeln'] = array(
			'zeit' => time(),
			'menge' => false,
			'wettkaempfe' => array()		
		);
		$_SESSION['flags']['abzuwickelndewettkaempfe'] = false;
	}
	elseif(!$erzwingen and $_SESSION['user']['wkabwickeln']['zeit']+600 > time()){ # die Wettkämpfe wurden innerhalb der letzten 10min eingelesen
		return true;
	}

	$ids = array();
	if($_gleinst['wettkaempfe_abwickeln']['trainingsgruppenwettkaempfe'] != 1 or $_SESSION['eingelogt'] == 'auto'){
		$_SESSION['user']['wkabwickeln']['menge'] = '-a';
	}
	# ermitteln was der User sehen darf
	if($_SESSION['user']['wkabwickeln']['menge'] == false){
		# Wettkämpfe aus Trainingsgruppenzuordung (als Schwimmer)
		$query = "SELECT wettkampfid
					FROM (".DB_PREFIX."mitglieder_gruppen as mt LEFT JOIN ".DB_PREFIX."gruppen_wettkaempfe as tw
					  ON mt.gruppenid = tw.gruppenid AND mt.mitgliedid = ".$_uid.") 
					  LEFT JOIN ".DB_PREFIX."eigenschaften as e ON e.artid=tw.wettkampfid AND e.art='w' AND e.eigenschaft='wkabwickeln'
					WHERE wettkampfid IS NOT NULL AND art IS NOT NULL";
		$_db->holeDaten($query);
		$ids['schwimmer'] = $_db->baueArray('wettkampfid','#');
		# Wettkämpfe aus Trainingsgruppenzuordung (als Trainer)
		$query = "SELECT DISTINCT wettkampfid
					FROM (".DB_PREFIX."gruppen_uebungsleiter as tu LEFT JOIN ".DB_PREFIX."gruppen_wettkaempfe as tw
					  ON tu.gruppenid = tw.gruppenid AND tu.uebungsleiterid = ".$_uid.") 
					  LEFT JOIN ".DB_PREFIX."eigenschaften as e ON e.artid=tw.wettkampfid AND e.art='w' AND e.eigenschaft='wkabwickeln'
					WHERE wettkampfid IS NOT NULL AND art IS NOT NULL";
		$_db->holeDaten($query);
		$ids['trainer'] = $_db->baueArray('wettkampfid','#');
		$_allerechte = pruefeRechte('w_abwickeln_allebearbeiten');

		if(count($ids['schwimmer'])>0 or count($ids['trainer'])>0){
			$_SESSION['user']['wkabwickeln']['menge'] = $_allerechte?'+t':'-t';
		}
		else{
			$_SESSION['user']['wkabwickeln']['menge'] = $_allerechte?'-a':'-t';
		}
	}
	
	if($_SESSION['user']['wkabwickeln']['menge'][1] == 'a'){
		$query = "SELECT artid FROM ".DB_PREFIX."eigenschaften WHERE art = 'w' AND eigenschaft = 'wkabwickeln'";
		$_db->holeDaten($query);
		$ids = array();
		if($_db->holeAnzahl()>0){
			$ids = $_db->baueArray('artid','#');
		}
	}
	else{
		if(!isset($ids['schwimmer'])){
			# Wettkämpfe aus Trainingsgruppenzuordung (als Schwimmer)
			$query = "SELECT wettkampfid
						FROM (".DB_PREFIX."mitglieder_gruppen as mt LEFT JOIN ".DB_PREFIX."gruppen_wettkaempfe as tw
						  ON mt.gruppenid = tw.gruppenid AND mt.mitgliedid = ".$_uid.") 
						  LEFT JOIN ".DB_PREFIX."eigenschaften as e ON e.artid=tw.wettkampfid AND e.art='w' AND e.eigenschaft='wkabwickeln'
						WHERE wettkampfid IS NOT NULL AND art IS NOT NULL";
			$_db->holeDaten($query);
			$ids['schwimmer'] = $_db->baueArray('wettkampfid','#');
		}
		if(!isset($ids['trainer'])){
			# Wettkämpfe aus Trainingsgruppenzuordung (als Trainer)
			$query = "SELECT DISTINCT wettkampfid
						FROM (".DB_PREFIX."gruppen_uebungsleiter as tu LEFT JOIN ".DB_PREFIX."gruppen_wettkaempfe as tw
						  ON tu.gruppenid = tw.gruppenid AND tu.uebungsleiterid = ".$_uid.") 
						  LEFT JOIN ".DB_PREFIX."eigenschaften as e ON e.artid=tw.wettkampfid AND e.art='w' AND e.eigenschaft='wkabwickeln'
						WHERE wettkampfid IS NOT NULL AND art IS NOT NULL";
			$_db->holeDaten($query);
			$ids['trainer'] = $_db->baueArray('wettkampfid','#');
		}
		$query = "SELECT artid 
					FROM ".DB_PREFIX."eigenschaften as e LEFT JOIN ".DB_PREFIX."gruppen_wettkaempfe as tw ON e.artid=tw.wettkampfid
					WHERE art = 'w' AND eigenschaft = 'wkabwickeln' AND gruppenid IS NULL
					GROUP BY e.artid";
		$_db->holeDaten($query);
		$ids['ohnebeschraenkung'] = $_db->baueArray('artid','#');
		$ids = array_unique(array_merge($ids['schwimmer'],$ids['trainer'],$ids['ohnebeschraenkung']));
	}

	if(is_array($ids) and count($ids)>0){
		$query = "SELECT id, CONCAT(titel, ' (', DATE_FORMAT(datum, '%e. %M %Y'), ')') as wettkampf
					FROM ".DB_PREFIX."wettkaempfe WHERE id IN (".implode(',',$ids).") ORDER BY datum";
		$_db->holeDaten($query);
		$_SESSION['user']['wkabwickeln']['wettkaempfe'] = $_db->baueArray('wettkampf','id');
		$_SESSION['flags']['abzuwickelndewettkaempfe'] = true;
	}
	else{
		$_SESSION['user']['wkabwickeln']['wettkaempfe'] = array();
		$_SESSION['flags']['abzuwickelndewettkaempfe'] = false;
	}
	$_SESSION['user']['wkabwickeln']['zeit'] = time();
}
# EOF
?>