<?php
require_once('../__inc/_start.inc.php');
$_seite = 11;
$erlaubt = pruefeRechte('m_aendern');
$_tmpl->assign('ueberschrift','Mitgliedsdaten ändern');
$titel = 'Mitgliedsdaten ändern';
$setzbareeigenschaften = array(
	'flags' => array(
		'aufnahmeformulargeben',
		'keinewettkampfteilnahme'
	),
	'werte' => array(
		'langname',
		'dsvidbeantragt',
		'maedchenname'
	)
);
if($_gleinst['features']['mitgliederkarten'] == 1){
	$setzbareeigenschaften['flags'][] = 'keinekartemachen';
}

if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{

if(isset($_GET) and isset($_GET['id'])){
	if(!ctype_digit($_GET['id'])){
		unset($_GET['id']);
	}
	else{
		$query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE id = ".$_GET['id']."";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler','Das Mitglied existiert nicht');
			unset($_GET['id']);
		}
	}
}

if(isset($_GET['id'])){
	# Rechtegruppen holen
	$query = "SELECT bezeichnung, id FROM ".DB_PREFIX."rechtegruppen
				WHERE SUBSTRING(bezeichnung,1,1) != '_' AND id NOT IN (2,3,4,6,7,8) ORDER BY sort";
	$_db->holeDaten($query);
	$_rechtegruppen = $_db->baueArray('bezeichnung','id');
	require_once(PFAD_INCLUDE.'func/holegruppen.inc.php');
	$_trainingsgruppen = holeGruppen();
	$query = "SELECT id, titel FROM ".DB_PREFIX."familien ORDER BY titel";
	$_db->holeDaten($query);
	$_familien = $_db->baueArray('titel','id');
}

if(!isset($_GET['id'])){
	require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
	$_inh .= mitgliedwaehlen('/mitglieder/aendern'.TKSWIM_DATEIENDUNG);
}
elseif(!isset($_POST['speichern']) or isset($_POST['telefonneu'])){
	if(isset($_POST['telefonneu'])){ # neue Telefonnummer anlegen
		$daten = $_POST;
		$daten['telefon'][] = array('id' => 'neu','nummer' => '', 'telefonart' => 1);
	}
	else{ # Daten des Mitgliedes holen
		$query = "SELECT id, vorname, nachname, mw, sonstiges, mitgliedskarte, familienid,
					  DATE_FORMAT(gebdatum,'%d.%m.%Y') as gebdatum, ausgetreten, dsvid, emailspeicherungok,
					  strasse, hausnr, plz, ort, email, DATE_FORMAT(eingetreten,'%d.%m.%Y') as eingetreten,
					  DATE_FORMAT(attestbis,'%d.%m.%Y') as attestbis
					FROM ".DB_PREFIX."mitglieder
					WHERE id = ".$_GET['id']."";
		$_db->holeDaten($query);
		$daten = $_db->holeZeile();
		# Eigenschaften des Mitgliedes holen
		$query = "SELECT eigenschaft, wert FROM ".DB_PREFIX."eigenschaften WHERE artid = ".$_GET['id']." AND art = 'm'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() > 0){
			$daten['_eigenschaften'] = array();
			foreach($_db->ergebnis['daten'] as $row){
				if(!isset($daten['_eigenschaften'][$row['eigenschaft']])){
					$daten['_eigenschaften'][$row['eigenschaft']] = $row['wert'];
				}
				else{
					$daten['_eigenschaften'][$row['eigenschaft']] = $row['wert'];
				}
			}
			foreach($daten['_eigenschaften'] as $key => $wert){
				if($key == 'langname'){
					list($v,$n) = explode('|',$wert);
					$daten['_eigenschaften'][$key] = array('vorname'=>$v,'nachname'=>$n);
				}
			}
		}
		# Rechtegruppen holen
		$query = "SELECT rechtegrid as id FROM ".DB_PREFIX."rechtegruppen_mitglieder
					WHERE mitgliedid = ".$_GET['id']." AND rechtegrid NOT IN (2,3,4,6,7)";
		$_db->holeDaten($query);
		$daten['rechtegr'] = $_db->baueArray('id','#');
		if(isset($_GET['telefonloeschid']) AND preg_match('~^[0-9]{1,9}$~',$_GET['telefonloeschid'])){
			if(!isset($_GET['sicher'])){
				$_tmpl->assign('frage','Soll die Telefonnummer wirklich gelöscht werden');
				$_tmpl->assign('query','id='.$_GET['id']);
				$_tmpl->assign('url', '/mitglieder/aendern'.TKSWIM_DATEIENDUNG);
				$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html').'<hr />';
			}
			else{
				$query = "DELETE FROM ".DB_PREFIX."telefon
							WHERE id = '".text_format($_GET['telefonloeschid'],'db')."' AND mitgliedid = ".$_GET['id'];
				$_db->fuehreQueryAus($query);
				weiterleiten('/mitglieder/aendern'.TKSWIM_DATEIENDUNG.'?id='.$_GET['id'],'Die Telefonnummer wurde gelöscht');
			}
		}
		# Telefonnummern holen
		$query = "SELECT id, telefonart, CONCAT(vorwahl,'/',nummer) as nummer
					FROM ".DB_PREFIX."telefon WHERE mitgliedid = ".$_GET['id']." ORDER BY telefonart";
		$_db->holeDaten($query);
		$daten['telefon'] = $_db->ergebnis['daten'];
		# Trainingsgruppen holen
		$query = "SELECT gruppenid as id FROM ".DB_PREFIX."mitglieder_gruppen WHERE mitgliedid = ".$_GET['id'];
		$_db->holeDaten($query);
		$daten['trainingsgruppe'] = $_db->baueArray('id','#');
		# Login holen
		$query = "SELECT anmeldename, freigeschaltet FROM ".DB_PREFIX."logins WHERE id = ".$_GET['id'];
		$_db->holeDaten($query);
		if($_db->holeAnzahl() == 0){
			$login = array('keinlogin'=>1);
		}
		else{
			$login = $_db->holeZeile();
		}
		$daten['login'] = $login;
	}
	$_tmpl->assign('daten',$daten);
}
else{
	$f = '';
	require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
	if(!isset($_POST['login']['keinlogin']) and prueferechte('m_logins')){
		# Anmeldename
		$tmp = '';
		$tmp .= pruefen($_POST['login']['anmeldename'],'leer','Der Anmeldename fehlt');
		$tmp .= pruefen($_POST['login']['anmeldename'],'regexpr','Der Anmeldename darf nur aus Kleinbuchstaben
				([a-z]) bestehen','^[a-z]+$');
		$tmp .= pruefen($_POST['login']['anmeldename'],'minlaenge','Der Anmeldename ist zu kurz (min 2 Zeichen)',2);
		$tmp .= pruefen($_POST['login']['anmeldename'],'maxlaenge','Der Anmeldename ist zu lang (max 50 Zeichen)',50);
		if($_POST['login']['anmeldename'] == 'admin'){
			$tmp .= 'Als Anmeldename kann »admin« nicht verwendet werden.';
		}
		if(empty($tmp)){
			$query = "SELECT id FROM ".DB_PREFIX."logins WHERE anmeldename = '".text_format($_POST['login']['anmeldename'],'db')."'";
			$_db->holeDaten($query);
			if($_db->holeAnzahl() == 1 and $_db->holeWert() != $_GET['id']){
				$tmp .= 'Der Anmeldename existiert bereits<br />';
			}
		}
		$f .= $tmp;
		# Passwort
		if(!empty($_POST['login']['passwort']) OR !empty($_POST['login']['passwort2'])){
			$f .= pruefen($_POST['login']['passwort'],'gleich','Die Passwörter sind nicht gleich',$_POST['login']['passwort2']);
			$f .= pruefen($_POST['login']['passwort'],'passwort','Das Passwort muss aus mindestens je eines der
					Zeichen [a-zöäüß], [A-ZÖÄÜ] und [0-9] enthalten und mindestens 8 Zeichen lang sein.');
		}
		else{
			$query = "SELECT passwort FROM ".DB_PREFIX."logins WHERE id = ".$_GET['id'];
			$_db->holeDaten($query);
			if($_db->holeAnzahl() == 0){
				$f .= 'Das Passwort fehlt<br />';
			}
		}
	}
	# Vor-, Nach-, Mädchen- und Langname
	$f .= pruefen($_POST['vorname'],'leer','Der Vorname fehlt');
	$f .= pruefen($_POST['vorname'],'maxlaenge','Der Vorname ist zu lang (max 30 Zeichen)',30);
	$f .= pruefen($_POST['nachname'],'leer','Der Nachname fehlt');
	$f .= pruefen($_POST['nachname'],'maxlaenge','Der Nachname ist zu lang (max 50 Zeichen)',50);
	if(isset($_POST['_eigenschaften']['maedchenname']) and !empty($_POST['_eigenschaften']['maedchenname'])){
		$f .= pruefen($_POST['_eigenschaften']['maedchenname'],'maxlaenge','Der Mädchenname ist zu lang (max 120 Zeichen)',120);
	}
	elseif(isset($_POST['_eigenschaften']['maedchenname']) and empty($_POST['_eigenschaften']['maedchenname'])){
		unset($_POST['_eigenschaften']['maedchenname']);
	}
	if(!empty($_POST['_eigenschaften']['langname']['vorname']) or !empty($_POST['_eigenschaften']['langname']['nachname'])){
		$f .= pruefen($_POST['_eigenschaften']['langname']['vorname'],'leer','Der Vorname des Langnamens fehlt');
		$f .= pruefen($_POST['_eigenschaften']['langname']['vorname'],'maxlaenge','Der Vorname des Langnamens ist zu lang (max 120 Zeichen)',120);
		$f .= pruefen($_POST['_eigenschaften']['langname']['nachname'],'leer','Der Nachname des Langnamens fehlt');
		$f .= pruefen($_POST['_eigenschaften']['langname']['nachname'],'maxlaenge','Der Nachname des Langnamens ist zu lang (max 120 Zeichen)',120);
	}
	# Geschlecht
	if(isset($_POST['mw'])){
		$f .= pruefen($_POST['mw'],'wertemenge','Das Geschlecht ist ungültig',array('m','w'));
	}
	else{
		$f .= 'Das Geschlecht fehlt<br />';
	}
	# Adresse
	$f .= pruefen($_POST['strasse'],'maxlaenge','Die Straße ist zu lang (max 40 Zeichen)',40);
	$f .= pruefen($_POST['hausnr'],'maxlaenge','Die Hausnummer ist zu lang (max 5 Zeichen)',5);
	$f .= pruefen($_POST['plz'],'regexpr','Die Postleitzahl darf nur aus 4 oder 5 Zahlen bestehen','^[0-9]{4,5}$');
	$f .= pruefen($_POST['ort'],'maxlaenge','Der Ort ist zu lang (max 40 Zeichen)',40);

	# Familie
	if($_POST['familienid'] != '-'){
		if(!in_array($_POST['familienid'],array_keys($_familien))){
			$f .= 'Die Familie existiert nicht<br />';
		}
	}

	# Telefon
	if(isset($_POST['telefon']) and is_array($_POST['telefon'])){
		foreach($_POST['telefon'] as $i => $tel){
			$f .= pruefen($_POST['telefon'][$i]['nummer'],'telefon','Die Nummer
					"'.$tel['nummer'].'" ist keine Telefonnummer',($tel['telefonart']==2?'-h-':$_gleinst['seitenweit']['standardvorwahl']));
			if(substr($_POST['telefon'][$i]['nummer'],0,4) == '-h-/'){
				$_POST['telefon'][$i]['nummer'] = substr($_POST['telefon'][$i]['nummer'], 4);
				$f .= 'Bei der Nummer "'.$tel['nummer'].'" fehlt die Vorwahl';
			}
			if($tel['id'] != 'neu'){
				$f .= pruefen($_POST['telefon'][$i]['id'],'zahl','Die ID der Nummer "'.$tel['nummer'].'" wurde manipuliert');
			}
			$f .= pruefen($_POST['telefon'][$i]['telefonart'],'wertemenge','Die Telefonart zu der Nummer
					"'.$tel['nummer'].'" ist ungültig',array_keys($_telefonarten));
		}
	}
	# E-Mail
	$f .= pruefen($_POST['email'],'email','Die E-Mailadresse ist ungültig');
	$f .= pruefen($_POST['email'],'maxlaenge','Die E-Mailadresse ist zu lang (max 50 Zeichen)',50);
	# Geburtsdatum
	$f .= pruefen($_POST['gebdatum'],'leer','Das Geburtsdatum fehlt');
	$f .= pruefen($_POST['gebdatum'],'datum','Das Geburtsdatum ist ungültig bzw. konnte nicht erkannt werden');
	# Eintrittsdatum, Austrittsjahr, Mitgliedskarte, DSV-ID
	if($_gleinst['features']['mitgliederkarten'] == 1){
		$f .= pruefen($_POST['mitgliedskarte'],'wertemenge','Der Wert für "Mitgliedskarte" ist ungültig',array_keys($_mitgliedskarten));
	}
	$f .= pruefen($_POST['eingetreten'],'datum','Das Eintrittsdatum ist ungültig bzw. konnte nicht erkannt werden',20);
	$f .= pruefen($_POST['ausgetreten'],'regexpr','Das Austrittsjahr ist ungültig','^[0-9]{4}$');
	$tmp = '';
	$tmp .= pruefen($_POST['dsvid'],'zahl','Die DSV-ID ist keine Zahl');
	$tmp .= pruefen($_POST['dsvid'],'minlaenge','Die DSV-ID ist zu kurz (sie muss genau 6 Ziffern lang sein)',6);
	$tmp .= pruefen($_POST['dsvid'],'maxlaenge','Die DSV-ID ist zu lang (sie muss genau 6 Ziffern lang sein)',6);
	if(empty($tmp) and !empty($_POST['dsvid'])){
		$query = "SELECT dsvid FROM ".DB_PREFIX."mitglieder WHERE dsvid IS NOT NULL AND id != ".$_GET['id'];
		$_db->holeDaten($query);
		$dsvids = $_db->baueArray('dsvid','#');
		if(in_array($_POST['dsvid'],$dsvids)){
			$f .= 'Es gibt bereits ein Mitglied mit dieser DSV-ID<br />';
		}
	}
	else{
		$f .= $tmp;
	}
	# Rechtegruppen
	if(isset($_POST['rechtegr']) and prueferechte('m_aendern_rechtegruppen')){
		$tmp = '';
		foreach($_POST['rechtegr'] as $rg){
			$tmp .= pruefen($rg,'wertemenge','-',array_keys($_rechtegruppen));
		}
		if(!empty($tmp)){
			$f .= 'Mindestens eine Rechtegruppe ist ungültig.';
		}
	}
	# Sonstiges
	$f .= pruefen($_POST['sonstiges'],'maxlaenge','Der Inhalt des Feldes »Sonstiges« ist zu lang (max 65000 Zeichen)',65000);
	# Trainingsgruppen, Attestbis
	if($_gleinst['features']['atteste'] == 1){
		$f .= pruefen($_POST['attestbis'],'datum','Das Datum im Feld »Attest gültig bis« ist ungültig.',20);
	}
	if(isset($_POST['trainingsgruppe']) and prueferechte('tr_gruppen_mitglieder_bearbeiten')){
		foreach($_POST['trainingsgruppe'] as $id){
			$f .= pruefen($id,'zahl','Die Trainingsgruppe ist manipuliert worden');
		}
	}
	if(!empty($f)){ # Es ist ein Fehler aufgetreten -> Fehler und Formular nochmal ausgeben
		$_tmpl->assign('fehler',$f);
		$_tmpl->assign('daten',$_POST);
	}
	else{ # Daten ok -> speichern
		# Login
		if(prueferechte('m_logins')){
			if(isset($_POST['login']['keinlogin'])){
				$query = "DELETE FROM ".DB_PREFIX."eigenschaften WHERE art='m' and eigenschaft='tmppasswort' and artid = ".$_GET['id'];
				$_db->fuehreQueryAus($query);
				$query = "DELETE FROM ".DB_PREFIX."logins WHERE id = ".$_GET['id'];
			}
			else{
				$query = "SELECT id, passwort FROM ".DB_PREFIX."logins WHERE id = ".$_GET['id'];
				$_db->holeDaten($query);
				$altespasswort = is_null($_db->holeWert('passwort'));
				if($_db->holeAnzahl()==1){
					$query = "UPDATE ".DB_PREFIX."logins SET ";
					$felder = [];
					if(!empty($_POST['login']['passwort'])){
						$felder[] = "passwort = '".text_format(password_hash($_POST['login']['passwort'], PASSWORD_DEFAULT), 'db')."'";
						if($altespasswort){
							$felder[] = "passwort_alt = NULL";
							$felder[] = "salz = NULL";
						}
					}
					$felder[] = "anmeldename = '".text_format($_POST['login']['anmeldename'],'db')."'";
					$felder[] = "freigeschaltet = ".(isset($_POST['login']['freigeschaltet'])?1:0);
					$query .= implode(', ', $felder);
					$query .= " WHERE id = ".$_GET['id'];
				}
				else{
					$query = "INSERT INTO ".DB_PREFIX."logins SET
								id = ".$_GET['id'].",
								anmeldename = '".text_format($_POST['login']['anmeldename'],'db')."',
								passwort = '".text_format(password_hash($_POST['login']['passwort'], PASSWORD_DEFAULT), 'db')."',
								freigeschaltet = ".(isset($_POST['login']['freigeschaltet'])?1:0);
				}
			}
			$_db->fuehreQueryAus($query);
		}

		# allgemeine Userdaten
		$updatefelder = array();
		$updatefelder[] = "vorname = '".text_format($_POST['vorname'],'db')."'";
		$updatefelder[] = "nachname = '".text_format($_POST['nachname'],'db')."'";
		if($_POST['familienid'] != '-'){
			$updatefelder[] = "familienid = ".$_POST['familienid'];
		}
		else{
			$updatefelder[] = "familienid = 0";
		}
		if(empty($_POST['dsvid'])){
			$updatefelder[] = "dsvid = NULL";
		}
		else{
			$updatefelder[] = "dsvid = '".text_format($_POST['dsvid'],'db')."'";
			# DSV-ID ist da -> Flag, dass die ID beantragt ist loeschen
			if(isset($_POST['_eigenschaften']) and isset($_POST['_eigenschaften']['dsvidbeantragt'])){
				unset($_POST['_eigenschaften']['dsvidbeantragt']);
			}
		}
		if($_gleinst['features']['mitgliederkarten'] == 1){
			$updatefelder[] = "mitgliedskarte = ".$_POST['mitgliedskarte'];
		}
		$updatefelder[] = "mw = '".text_format($_POST['mw'],'db')."'";
		$updatefelder[] = "gebdatum = '".text_format($_POST['gebdatum'],'dbdatum')."'";
		$updatefelder[] = "eingetreten = ".(empty($_POST['eingetreten'])?'NULL':"'".text_format($_POST['eingetreten'],'dbdatum')."'");
		$updatefelder[] = "ausgetreten =".(empty($_POST['ausgetreten'])?'NULL':"'".text_format($_POST['ausgetreten'],'db')."'");
		if($_gleinst['features']['atteste'] == 1){
			$updatefelder[] = "attestbis =".(empty($_POST['attestbis'])?'NULL':"'".text_format($_POST['attestbis'],'dbdatum')."'");
		}
		$updatefelder[] = "sonstiges = ".(empty($_POST['sonstiges'])?'NULL':"'".text_format($_POST['sonstiges'],'db')."'");
		$updatefelder[] = "strasse = ".(empty($_POST['strasse'])?'NULL':"'".text_format($_POST['strasse'],'db')."'");
		$updatefelder[] = "hausnr = ".(empty($_POST['hausnr'])?'NULL':"'".text_format($_POST['hausnr'],'db')."'");
		$updatefelder[] = "plz = ".(empty($_POST['plz'])?'NULL':"'".text_format($_POST['plz'],'db')."'");
		$updatefelder[] = "ort = ".(empty($_POST['ort'])?'NULL':"'".text_format($_POST['ort'],'db')."'");
		$updatefelder[] = "email = ".(empty($_POST['email'])?'NULL':"'".text_format($_POST['email'],'db')."'");
		$updatefelder[] = "emailspeicherungok = ".(isset($_POST['emailspeicherungok'])?'1':'0');
		$query = "UPDATE ".DB_PREFIX."mitglieder SET ".implode(', ',$updatefelder)." WHERE id = ".$_GET['id']."";
		$_db->fuehreQueryAus($query);

		# Rechtegruppen
		if(pruefeRechte('m_aendern_rechtegruppen')){
			if(!isset($_POST['rechtegr'])){
				$_POST['rechtegr'] = array();
			}
			# vorhandene Rechtegruppen holen
			$query = "SELECT DISTINCT rechtegrid as id FROM ".DB_PREFIX."rechtegruppen_mitglieder
						WHERE mitgliedid = ".$_GET['id']." AND rechtegrid NOT IN (2,3,4,6,7)";
			$_db->holeDaten($query);
			$vorhandenerechtegruppen = $_db->baueArray('id','#');
			sort($vorhandenerechtegruppen);
			$vorhandenerechtegruppen = implode('_', $vorhandenerechtegruppen);
			# zu setzende in mit mid in Array packen
			$rg = $zusetzendegruppen = array();
			foreach($_POST['rechtegr'] as $rechtegr){
				$rg[] = '('.$_GET['id'].','.$rechtegr.')';
				$zusetzendegruppen[] = $rechtegr;
			}
			sort($zusetzendegruppen);
			$zusetzendegruppen = implode('_', $zusetzendegruppen);
			if($vorhandenerechtegruppen != $zusetzendegruppen){ # Gruppen haben sich geändert -> schreiben
				$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE mitgliedid = ".$_GET['id'];
				$_db->fuehreQueryAus($query);
				if(count($rg)>0){
					$query = "INSERT INTO ".DB_PREFIX."rechtegruppen_mitglieder (mitgliedid,rechtegrid) VALUES ".implode(', ',$rg);
					$_db->fuehreQueryAus($query);
				}
			}
		}
		require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
		mitglieder_rechtegruppensetzen($_GET['id']);

		# Telefonnummern
		if(isset($_POST['telefon']) and is_array($_POST['telefon'])){
			foreach($_POST['telefon'] as $telefon){
				if(empty($telefon['nummer'])){
					continue;
				}
				list($vorwahl,$nummer) = explode('/',$telefon['nummer']);
				if($telefon['id'] == 'neu'){
					$query = "INSERT INTO ".DB_PREFIX."telefon (telefonart, vorwahl, nummer, mitgliedid)
								VALUES (".$telefon['telefonart'].", '".$vorwahl."', '".$nummer."',".$_GET['id'].")";
				}
				else{
					$query = "UPDATE ".DB_PREFIX."telefon
								SET telefonart = ".$telefon['telefonart'].", vorwahl = '".$vorwahl."', nummer = '".$nummer."'
								WHERE mitgliedid = ".$_GET['id']." AND id = ".$telefon['id']."";
				}
				$_db->fuehreQueryAus($query);
			}
		}

		# Trainingsgruppen
		if(prueferechte('tr_gruppen_mitglieder_bearbeiten')){
			# vorhandene Trainingsgruppen holen
			$query = "SELECT gruppenid as id FROM ".DB_PREFIX."mitglieder_gruppen WHERE mitgliedid = ".$_GET['id'];
			$_db->holeDaten($query);
			$vorhandenegruppen = $_db->baueArray('id','#');
			sort($vorhandenegruppen);
			$vorhandenegruppen = implode('_', $vorhandenegruppen);
			# zu setzende Gruppen holen
			if(isset($_POST['trainingsgruppe']) and is_array($_POST['trainingsgruppe'])){
				$zusetzendegruppen = $_POST['trainingsgruppe'];
				sort($zusetzendegruppen);
				$zusetzendegruppen = implode('_', $zusetzendegruppen);
			}
			else{
				$zusetzendegruppen = '';
			}
			if($vorhandenegruppen != $zusetzendegruppen){ # Gruppen haben sich geändert -> ändern
				$query = "DELETE FROM ".DB_PREFIX."mitglieder_gruppen WHERE mitgliedid = ".$_GET['id'];
				$_db->fuehreQueryaus($query);
				$werte = array();
				if(isset($_POST['trainingsgruppe'])){
					foreach($_POST['trainingsgruppe'] as $id){
						$werte[] = '('.$_GET['id'].','.$id.')';
					}
					$query = "INSERT INTO ".DB_PREFIX."mitglieder_gruppen
								(mitgliedid,gruppenid)
								VALUES ".implode(', ',$werte)."";
					$_db->fuehreQueryaus($query);
				}
			}
		}

		# Eigenschaften
		# zu schreibende Eigenschaften
		$zuschreibende = array();
			# Werte: langname, dsvidbeantragt, maedchenname
		foreach($setzbareeigenschaften['werte'] as $wert){
			if(!isset($_POST['_eigenschaften'][$wert])){
				continue;
			}
			switch($wert){
			case 'dsvidbeantragt':
				$query = "SELECT wert FROM ".DB_PREFIX."eigenschaften
							WHERE artid = ".$_GET['id']." AND art = 'm' AND eigenschaft = 'dsvidbeantragt'";
				$_db->holeDaten($query);
				if($_db->ergebnis['anzahl'] == 0){
					$zuschreibende['dsvidbeantragt'] = date('d.m.Y');
				}
				else{
					$zuschreibende['dsvidbeantragt'] = $_db->holeWert();
				}
				break;
			case 'langname':
				if(!empty($_POST['_eigenschaften']['langname']['nachname'])){
					$zuschreibende['langname'] = $_POST['_eigenschaften']['langname']['vorname'].'|'.$_POST['_eigenschaften']['langname']['nachname'];
				}
				break;
			default:
				$zuschreibende[$wert] = $_POST['_eigenschaften'][$wert];
				break;
			}
		}
			# Flags: aufnahmeformularfehlt, keinekartemachen, keinewettkampfteilnahme
		foreach($setzbareeigenschaften['flags'] as $flag){
			if(isset($_POST['_eigenschaften'][$flag])){
				$zuschreibende[$flag] = 1;
			}
		}
		# vorhandene Eigenschaften holen
		if(count($zuschreibende) > 0){ # es gibt was zum Schreiben
			$query = "SELECT eigenschaft, wert FROM ".DB_PREFIX."eigenschaften
						WHERE artid = ".$_GET['id']." AND art = 'm'";
			$_db->holeDaten($query);
			$vorhandenewerte = array();
			$vorhandeneids = array();
			if($_db->ergebnis['anzahl'] > 0){
				foreach($_db->ergebnis['daten'] as $row){
					if(!isset($vorhandenewerte[$row['eigenschaft']])){
						$vorhandenewerte[$row['eigenschaft']] = '';
					}
					$vorhandenewerte[$row['eigenschaft']] = $row['wert'];
				}
			}
			$querys = array();
			$queryanfang = array(
				'update' => 'UPDATE '.DB_PREFIX.'eigenschaften SET ',
				'insert' => "INSERT INTO ".DB_PREFIX."eigenschaften (art,artid,eigenschaft,wert) VALUES ('m',".$_GET['id'].","
			);
			$queryende = array(
				'update' => " WHERE artid = ".$_GET['id']." AND art = 'm' AND eigenschaft = ",
				'insert' => ")"
			);
			foreach($zuschreibende as $eigenschaft => $wert){
				if(isset($vorhandenewerte[$eigenschaft])){
					$querys[] = $queryanfang['update']." wert = '".text_format($wert,'db')."'".$queryende['update']."'".$eigenschaft."'";
				}
				else{
					$querys[] = $queryanfang['insert']."'".$eigenschaft."', '".text_format($wert,'db')."'".$queryende['insert'];
				}
				unset($vorhandenewerte[$eigenschaft]);
			}

			if(count($vorhandenewerte) > 0){ # restliche Werte loeschen
				$querys[] = "DELETE FROM ".DB_PREFIX."eigenschaften
							WHERE artid = ".$_GET['id']." AND art = 'm' AND eigenschaft IN ('".implode("', '",array_keys($vorhandenewerte))."')
								AND eigenschaft != 'alteadresse'";
			}
			# gespeicherte Querys an die Datenbank schicken
			if(count($querys) > 0){
				foreach($querys as $q){
					$_db->fuehreQueryAus($q);
				}
			}
		}
		else{ # es ist keine setzbare Eigenschaft mehr gesetzt -> evtl. vorhandene Werte loeschen
			$eigenschaften = array();
			foreach($setzbareeigenschaften['flags'] as $e){
				$eigenschaften[] = $e;
			}
			foreach($setzbareeigenschaften['werte'] as $e){
				$eigenschaften[] = $e;
			}
			$query = "DELETE FROM ".DB_PREFIX."eigenschaften
						WHERE artid = ".$_GET['id']." AND art = 'm' AND eigenschaft IN ('".implode("', '",$eigenschaften)."')
						AND eigenschaft != 'alteadresse'";
			$_db->fuehreQueryAus($query);
		}

		# Wenn das Mitglied ausgetreten ist, die entsprechenden Aktionen durchführen
		if(!empty($_POST['ausgetreten'])){
			require_once(PFAD_INCLUDE.'func/setzemitgliedaufausgetreten.inc.php');
			setzeMitgliedAufAusgetreten($_GET['id'],$_POST['ausgetreten'],$_db);
		}

		$text = 'Der Datensatz wurde erfolgreich geändert';
		if(isset($_POST['naechsteaktion'])){
			$url = '';
			switch($_POST['naechsteaktion']){
			case 'formular':
				$url = '/mitglieder/aendern'.TKSWIM_DATEIENDUNG.'?id='.$_GET['id'];
				break;
			case 'detail':
				$url = '/mitglieder/anzeigen'.TKSWIM_DATEIENDUNG.'?id='.$_GET['id'];
				break;
			case 'mitglied':
				$url = '/mitglieder/aendern'.TKSWIM_DATEIENDUNG;
				break;
			default:
				break;
			}
			$_SESSION['naechsteaktion'] = $_POST['naechsteaktion'];
			if(!empty($url)){
				weiterleiten($url,$text);
			}
		}
	}
}

if(isset($_GET['id'])){
	$_tmpl->assign('familien',$_familien);
	$_tmpl->assign('telefonarten',$_telefonarten);
	$_tmpl->assign('mitgliedskarten',$_mitgliedskarten);
	$_tmpl->assign('trainingsgruppen',$_trainingsgruppen);
	$_tmpl->assign('rechtegr',$_rechtegruppen);
	$_tmpl->assign('mitglkarte', $_gleinst['features']['mitgliederkarten']);
	$_tmpl->assign('atteste', $_gleinst['features']['atteste']);
	if(pruefeRechte('m_logins')){
		# Javascript-Code für die Felder für die Logindaten
		$_tmpl->tk_javascriptzuweisen('onready', "\$('#logindaten').css('display', (\$('input[name=\"login[keinlogin]\"]').attr('checked')?'none':''));");
		$_tmpl->tk_javascriptzuweisen('inline',"function logindatenanzeigen(){
  if($('input[name=\"login[keinlogin]\"]').attr('checked')){ \$('#logindaten').slideUp(100); }
  else{ \$('#logindaten').slideDown(100); }
}");
		$_tmpl->tk_javascriptzuweisen('inline',"function anmeldename(){
  var v = \$('#vorname').val();
  var n = \$('#nachname').val();
  if(v == '' || n == ''){
    \$().message('Für diese Funktion müssen die Felder für Vor- und Nachname ausgefüllt sein.');
  }
  else{
    if(v.indexOf('-')>0){ var tmp = v.split('-'); var vnamen = tmp[0]; }
    else if(v.indexOf(' ')>0){ var tmp = v.split(' '); var vnamen = tmp[0]; }
    else{ var vnamen = v; }
    var neu = vnamen+n;
    neu = neu.toLowerCase();
    neu = neu.replace('ö','oe');
    neu = neu.replace('ä','ae');
    neu = neu.replace('ü','ue');
    neu = neu.replace('ß','ss');
    \$('#anmeldename').val(neu.toLowerCase());
  }
}");
	}

	# diverse Javascriptfunktionen
	# heute-Funktion
	$_tmpl->tk_javascriptzuweisen('inline',"function heute(feld){
var jetzt = new Date();
feld.value = jetzt.getDate()+'.'+(jetzt.getMonth()+1)+'.'+jetzt.getFullYear();
return;
}");

	# Langname- und Mädchennamezeile
	if(!isset($daten['_eigenschaften']['langname']) or (empty($daten['_eigenschaften']['langname']['nachname']) and empty($daten['_eigenschaften']['langname']['vorname']))){
		$weg = 'langnamezeile';
	}
	else{
		$weg = 'langnameanlegenlink';
	}
	$_tmpl->tk_javascriptzuweisen('onready',"\$('#".$weg."').css('display', 'none');");
	if(!isset($daten['_eigenschaften']['maedchenname']) or empty($daten['_eigenschaften']['maedchenname'])){
		$weg = 'maedchennamezeile';
	}
	else{
		$weg = 'maedchennameanlegenlink';
	}
	$_tmpl->tk_javascriptzuweisen('onready',"\$('#".$weg."').css('display', 'none');");
	$_tmpl->tk_javascriptzuweisen('inline',"function langnameanlegen(){
  \$('#langnamezeile').css('display','');
  var f = document.forms[0];
  f.elements['_eigenschaften[langname][vorname]'].value = f.elements['vorname'].value;
  f.elements['_eigenschaften[langname][nachname]'].value = f.elements['nachname'].value;
  \$('#langnameanlegenlink').css('display','none');
  return false;
}");
	$_tmpl->tk_javascriptzuweisen('inline',"function maedchennameanlegen(){
  \$('#maedchennamezeile').css('display','');
  var f = document.forms[0];
  f.elements['_eigenschaften[maedchenname]'].value = f.elements['nachname'].value;
  \$('#maedchennameanlegenlink').css('display','none');
  return false;
}");

	# speichern der alten Adresse
	$_tmpl->tk_javascriptzuweisen('inline',"function alteadressespeichern(mid){
  $.post(ajaxdatei, {mimeType:'text/xml',aktion:'alteadressespeichern',mid:mid},
    function(a){
      if(a=='0'){ alert('Die Adresse konnte nicht als alte Adresse gespeichert werden.'); }
      else{ $().message('Die aktuelle Adresse wurde als alte Adresse gespeichert.'); }
    },'text');
}");

	if(pruefeRechte('m_familien_bearbeiten')){
		$_tmpl->tk_javascriptzuweisen('onready',"$('#familieneu').dialog({
  bgiframe: true, autoOpen: false, modal: true, width: 'auto', minHeight:50,
  closeText: '×', height: 'auto', resizable: false, title: 'neue Familie anlegen'
});");
	$_tmpl->tk_javascriptzuweisen('inline',"function familieanlegen(art){
  if(art == 'fenster'){
    \$('#familieneu').dialog('open');
    \$(\"input[name='familieneu_titel']\").focus();
    return;
  }
  else{
    var familientitel = \$(\"input[name='familieneu_titel']\").val();
    $.post(ajaxdatei, {mimeType:'text/xml',aktion:'familieanlegen',familientitel:familientitel},
      function(a){
        if($(a).find('code').text() > 0){ // erfolgreich
          \$().message($(a).find('meldung').text());
          \$('#familie').empty();
          \$('#familie').append($(a).find('daten').html());
          \$('#familieneu').dialog('close');
          \$(\"input[name='familieneu_titel']\").val('');
        }
        else{ // Fehler
          $().message('Fehler: '+$(a).find('meldung').text());
          if($(a).find('code').text() == -2 && $('#familie option:selected').val() == '-'){
            $('#familie option[value='+$(a).find('vorhandene').text()+']').attr('selected', 'selected');
          }
        }
      },'text');
  }
}");
	}

	# Laden der JS-Dateien anschubsen
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschen').tkswim_loeschfrage({art:'telefonnummer',frage:'Soll die Telefonnummer wirklich gelöscht werden?',elternelement:'span'});");
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.plzortergaenzen').tkswim_plzortergaenzen();");
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.datumwahl').tkswim_datumwahl();");
	$_inh .= $_tmpl->fetch('mitglieder/11.mitglied-formular.inc.html');
}

} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
